/* Illustrations */

.carousel-wrapper {
  container: carouselWrapper / inline-size;
  max-inline-size: 840px;
  display: grid;
  position: relative;
  grid-template-rows:
    [display-start] 1fr
    [navigation-start] auto
    [display-end navigation-end];
  grid-template-columns: 1fr;
  gap: 0.5rem;
  margin: auto;
}

.carousel-display {
  contain: content;
  content-visibility: auto;
  border: 3px solid var(--border-color);
  border-radius: var(--radius-card);
  box-shadow: 0.35em 0.3em 0 0 var(--accent-primary);
}

/* Default */
.carousel-display img {
  display: block;
  inline-size: 100%;
  block-size: auto;
  aspect-ratio: 16 / 9;
  object-fit: cover;
}

/* If you're special */
.carousel-display img.is-natural {
  aspect-ratio: auto;
  block-size: auto;
  object-fit: contain;
}

/* Makes the thumbnails all uniform */
.carousel-button img {
  display: block;
  inline-size: 100%;
  block-size: auto;
  object-fit: cover;
  aspect-ratio: 16 / 9;
}

.carousel-nav {
  z-index: 10;
  block-size: 100%;
  container: navigation / inline-size;
  grid-column: 1 / -1;
  display: grid;
  gap: 1em;
  position: relative;
}

.carousel-control-btn-group {
  place-self: center;
  gap: 1rem;
  display: flex;
}

.carousel-control-btn {
  cursor: pointer;
  width: clamp(2rem, 1.0234rem + 3.125vw, 2.625rem);
  aspect-ratio: 1;
  background: none;
  border: none;
  overflow: hidden;
  padding-inline: 25px;

  :active {
    transform: scale(0.86);
  }

  &:focus-visible {
    outline: 2px dotted var(--accent-primary);
    outline-offset: 5px;
    border-radius: 5px;
    box-shadow: 0 0 10px 0 var(--focus-glow);
  }
}

.carousel-control-icon {
  display: flex;
  position: relative;
  aspect-ratio: 1;
  padding: 0.25rem;
  gap: 0.5rem;
}

.carousel-control-icon > * {
  flex-shrink: 0;
}

.icon-svg {
  place-self: center;
  font-size: 1.25rem;
  color: var(--accent-primary);
  transition:
    transform 0.5s,
    opacity 0.5s;
}

[class$="-double"] {
  opacity: 0;
  transform: scale(0);
}

.next .carousel-control-icon {
  flex-direction: row-reverse;
}

.carousel-track {
  --container-width: 100cqi;
  --gap: 1rem;
  --visible-items: 5;
  --total-gap: calc((var(--visible-items) - 1) * var(--gap));
  --item-width: calc(
    (var(--container-width) - var(--total-gap)) / var(--visible-items)
  );
  scrollbar-gutter: stable;
  container: scrollContainer / inline-size;
  list-style: none;
  display: flex;
  padding: 0.5rem;
  justify-content: start;
  gap: var(--gap);
  overflow-x: auto;
  scrollbar-width: none;
  scroll-behavior: smooth;
  scroll-snap-type: x proximity;
  overscroll-behavior: contain;
  scroll-padding-inline: 0.5rem;
}

.carousel-track::-webkit-scrollbar {
  display: none;
}

.carousel-item {
  scroll-snap-align: start;
  flex: 1 0 var(--item-width);
}

.carousel-button {
  cursor: pointer;
  display: grid;
  position: relative;
  width: 100%;
  height: 100%;
  outline: 3px solid transparent;
  outline-offset: 0.27rem;
  border: none;
  border-radius: 5px;
  overflow: hidden;
  background: none;
  transform: scale(0.93);
  transform-origin: center;
  transition:
    var(--transition-transform),
    filter 0.5s ease;
}

.carousel-button[aria-pressed="true"] {
  outline-color: var(--accent-primary);
  transform: initial;
  border-radius: 2.5px;
}

.carousel-button:not([aria-pressed="true"]) {
  filter: grayscale(90%) opacity(0.5);
  transition: filter 0.25s ease;

  &:focus-visible,
  &:hover {
    outline: 1.5px solid var(--focus-visible-carousel);
    outline-offset: 5px;
    border-radius: 2.5px;
  }
}

.thumbnail {
  contain-intrinsic-size: 16 / 9;
  content-visibility: auto;
  overflow: hidden;
}

@container navigation (max-width: 780px) {
  .carousel-nav-scroll-container {
    --visible-items: 4;
  }
}

@container navigation (max-width: 662px) {
  .carousel-nav-scroll-container {
    --visible-items: 3;
  }
}

@media (hover: hover) {
  .icon-svg {
    transition-timing-function: linear(
      0,
      0.027 2.8%,
      0.107 6%,
      0.557 18.2%,
      0.747 24.4%,
      0.878 30.4%,
      0.962 36.6%,
      1.027 51.6%,
      1
    );
  }

  .carousel-control-btn:hover .icon-svg {
    color: var(--text-primary);
  }

  .next:hover .carousel-control-icon > .chevron-right {
    transform: translateX(calc(100% + 0.25rem)) scale(0);
    opacity: 0;
  }

  .next:hover .carousel-control-icon > .chevron-right-double {
    transform: scale(1) translateX(calc(100% + 0.5rem));
    opacity: 1;
  }

  .prev:hover .carousel-control-icon > .chevron-left {
    transform: translateX(calc(-100% - 0.25rem)) scale(0);
    opacity: 0;
  }

  .prev:hover .carousel-control-icon > .chevron-left-double {
    transform: scale(1) translateX(calc(-100% - 0.5rem));
    opacity: 1;
  }

  .carousel-button:not([aria-pressed="true"]):hover {
    filter: none;
  }
}

@media (prefers-reduced-motion: reduce) {
  .icon-svg,
  .carousel-button {
    transition: none;
  }
}
